from os import environ
from subprocess import run
from pybuilder.core import init, task
from ddadevops import *

default_task = "dev"

name = "dda-backup"
MODULE = "not-used"
PROJECT_ROOT_PATH = "."
version = "1.0.15-dev"

@init
def initialize(project):
    input = {
        "name": name,
        "module": MODULE,
        "stage": "notused",
        "project_root_path": PROJECT_ROOT_PATH,
        "build_types": [],
        "mixin_types": ["RELEASE"],
        "release_primary_build_file": "build.py",
        "release_secondary_build_files": [            
            "infrastructure/docker/build.py"
        ],
        "release_artifact_server_url": "https://repo.prod.meissa.de",
        "release_organisation": "meissa",
        "release_repository_name": name,
        "release_artifacts": [],
        "release_main_branch": "master",
    }

    build = ReleaseMixin(project, input)
    build.initialize_build_dir()

@task
def patch(project):
    build = get_devops_build(project)
    build.update_release_type("PATCH")
    release(project)


@task
def minor(project):
    build = get_devops_build(project)
    build.update_release_type("MINOR")
    release(project)


@task
def major(project):
    build = get_devops_build(project)
    build.update_release_type("MAJOR")
    release(project)


@task
def prepare(project):
    build = get_devops_build(project)
    build.prepare_release()


@task
def tag(project):
    build = get_devops_build(project)
    build.tag_bump_and_push_release()

@task
def publish_artifacts(project):
    build = get_devops_build(project)
    build.publish_artifacts()

def release(project):
    prepare(project)
    tag(project)
